/*
 * \file UARTDevice.h
 * This is the header file for the UARTDevice module.
 *
 * Copyright 2013-2015 Freescale Semiconductor, Inc.
 * Copyright 2016-2017 NXP
 * All rights reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

#ifndef __UART_DEV__
#define __UART_DEV__

/************************************************************************************
*************************************************************************************
* Include
*************************************************************************************
************************************************************************************/
#include "hsdkOSCommon.h"
#include "PhysicalDevice.h"

#ifdef __cplusplus
extern "C" {
#endif

/*! *********************************************************************************
*************************************************************************************
* Public type definitions
*************************************************************************************
********************************************************************************** */
/**
 * @brief Structure to identify a UART port.
 */
typedef struct {
    char *deviceName;   /**< The name of the device, in some cases the system path of the device. */
    File portHandle;    /**< The file abstraction of the device in the operating system. */
} UARTHandle;

/*! *********************************************************************************
*************************************************************************************
* Public memory declarations
*************************************************************************************
********************************************************************************** */

/*! *********************************************************************************
*************************************************************************************
* Public macros
*************************************************************************************
********************************************************************************** */

/*! *********************************************************************************
*************************************************************************************
* Public prototypes
*************************************************************************************
********************************************************************************** */
int AttachToUARTDevice(PhysicalDevice *pDevice, char *deviceName);
int DetachFromUARTDevice(PhysicalDevice *pDevice);

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif
